;Filename: GetChar.s
;Part: ADuC702x.
;Created: 20/04/2004
;Updated: 28/06/2005
;Author: Eckart Hartmann.
;This file is in beta sampling.

#include        <ADuC702x.IAR.equ>

; getchar==========Reads the UART data register.
; C Function prototype: int getchar(void);
; Description of Function: Waits for character from UART then returns it.
; User interface:
;   Call getkey.
;   Returns COMRX when available:
; Robustness:  Waits until character available.
; Side effects: Corrupts r3.


                RSEG CODE
                MODULE getchar
                PUBLIC getchar
                CODE32

getchar:
        mov     r3,#0xff0000            ;r3 = Z_BASE;
        orr     r3,r3,#0xff000000
GkLoop: ldr     r0,[r3,#Z_COMSTA0]      ;Loop till data ready.
        ands    r0,r0,#0x01
        beq     GkLoop
        ldrb    r0,[r3,#Z_COMRX]        ;Get COMRX.
        bx      lr                      ;return.


                 ENDMOD  getchar

                 END

